<!DOCTYPE html>
<html lang="en">

<head>
    <title> All APIs sample cho Devcamp Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .divider {
        border-bottom: 2px solid #0163ee;
        margin-top: 2rem;
        margin-bottom: 2rem;
        width: 23rem;
    }
</style>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";

    // API lấy danh sách sinh viên (Students)
    function onGetStudentListClick() {
        var vAPI_URL = gBASE_URL + "/students";
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", vAPI_URL, false);
        vXhttp.send();
        if (vXhttp.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText);
        }
    }

    // API lấy chi tiết 01 sinh viên by id
    function onGetStudentByIdClick() {
        const vAPI_URL = gBASE_URL + "/students/";
        var vStudentId = 2;
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + vStudentId, false);
        vXmlHttp.send();
        if (vXmlHttp.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttp.responseText);
        }
    }

    // API để xóa (delete) một sinh viên theo Id
    function onDeleteStudentByIdClick() {
        const vAPI_URL = gBASE_URL + "/students/";
        // id student sẽ xóa
        var vStudentId = 11;

        var vXmlhttp = new XMLHttpRequest();
        vXmlhttp.open("DELETE", vAPI_URL + vStudentId, true);
        vXmlhttp.send();

        vXmlhttp.onreadystatechange = function () {
            // xóa thành công student
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log("Delete student " + vStudentId + " thành công!");
            }
        }
    }
</script>

<body>
    <div class="container mt-4">
        <div class="row form-group">
            <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
        </div>
        <div class="row form-group">
            <p id="testP" class="h4"> Demo 03 Sample API </p>
        </div>
        <div class="row form-group">
            <button class="btn btn-info m-1" onclick="onGetStudentListClick()">Lấy danh sách Sinh viên</button>
            <button class="btn btn-warning m-1" onclick="onGetStudentByIdClick()">Lấy chi tiết 1 sinh viên theo Id</button>
            <button class="btn btn-warning m-1" onclick="onDeleteStudentByIdClick()">Xóa 1 sinh viên theo Id</button>
        </div>
    </div>
</body>

</html>